// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	. "gitlab.com/commonground/nlx/fsc-nlx/auditlog/ports/rest/api/models"
)

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// GetRecords request
	GetRecords(ctx context.Context, params *GetRecordsParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreateRecordsWithBody request with any body
	CreateRecordsWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreateRecords(ctx context.Context, body CreateRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// UnsetRecordsUnderReviewWithBody request with any body
	UnsetRecordsUnderReviewWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	UnsetRecordsUnderReview(ctx context.Context, body UnsetRecordsUnderReviewJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// SetRecordsUnderReviewWithBody request with any body
	SetRecordsUnderReviewWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	SetRecordsUnderReview(ctx context.Context, body SetRecordsUnderReviewJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetHealth request
	GetHealth(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) GetRecords(ctx context.Context, params *GetRecordsParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetRecordsRequest(c.Server, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateRecordsWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateRecordsRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateRecords(ctx context.Context, body CreateRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateRecordsRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) UnsetRecordsUnderReviewWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewUnsetRecordsUnderReviewRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) UnsetRecordsUnderReview(ctx context.Context, body UnsetRecordsUnderReviewJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewUnsetRecordsUnderReviewRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) SetRecordsUnderReviewWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewSetRecordsUnderReviewRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) SetRecordsUnderReview(ctx context.Context, body SetRecordsUnderReviewJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewSetRecordsUnderReviewRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetHealth(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetHealthRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewGetRecordsRequest generates requests for GetRecords
func NewGetRecordsRequest(server string, params *GetRecordsParams) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/auditlogs")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Cursor != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "cursor", runtime.ParamLocationQuery, *params.Cursor); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Limit != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "limit", runtime.ParamLocationQuery, *params.Limit); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.SortOrder != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "sort_order", runtime.ParamLocationQuery, *params.SortOrder); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.After != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "after", runtime.ParamLocationQuery, *params.After); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Before != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "before", runtime.ParamLocationQuery, *params.Before); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if queryFrag, err := runtime.StyleParamWithLocation("form", true, "group_id", runtime.ParamLocationQuery, params.GroupId); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

		if params.Id != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "id", runtime.ParamLocationQuery, *params.Id); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.CorrelationId != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "correlation_id", runtime.ParamLocationQuery, *params.CorrelationId); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.ContentHash != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "content_hash", runtime.ParamLocationQuery, *params.ContentHash); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.ServiceName != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "service_name", runtime.ParamLocationQuery, *params.ServiceName); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.UnderReview != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "under_review", runtime.ParamLocationQuery, *params.UnderReview); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewCreateRecordsRequest calls the generic CreateRecords builder with application/json body
func NewCreateRecordsRequest(server string, body CreateRecordsJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreateRecordsRequestWithBody(server, "application/json", bodyReader)
}

// NewCreateRecordsRequestWithBody generates requests for CreateRecords with any type of body
func NewCreateRecordsRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/auditlogs")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewUnsetRecordsUnderReviewRequest calls the generic UnsetRecordsUnderReview builder with application/json body
func NewUnsetRecordsUnderReviewRequest(server string, body UnsetRecordsUnderReviewJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewUnsetRecordsUnderReviewRequestWithBody(server, "application/json", bodyReader)
}

// NewUnsetRecordsUnderReviewRequestWithBody generates requests for UnsetRecordsUnderReview with any type of body
func NewUnsetRecordsUnderReviewRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/auditlogs/review")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("DELETE", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewSetRecordsUnderReviewRequest calls the generic SetRecordsUnderReview builder with application/json body
func NewSetRecordsUnderReviewRequest(server string, body SetRecordsUnderReviewJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewSetRecordsUnderReviewRequestWithBody(server, "application/json", bodyReader)
}

// NewSetRecordsUnderReviewRequestWithBody generates requests for SetRecordsUnderReview with any type of body
func NewSetRecordsUnderReviewRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/auditlogs/review")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("PUT", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewGetHealthRequest generates requests for GetHealth
func NewGetHealthRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/health")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// GetRecordsWithResponse request
	GetRecordsWithResponse(ctx context.Context, params *GetRecordsParams, reqEditors ...RequestEditorFn) (*GetRecordsResponse, error)

	// CreateRecordsWithBodyWithResponse request with any body
	CreateRecordsWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateRecordsResponse, error)

	CreateRecordsWithResponse(ctx context.Context, body CreateRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateRecordsResponse, error)

	// UnsetRecordsUnderReviewWithBodyWithResponse request with any body
	UnsetRecordsUnderReviewWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*UnsetRecordsUnderReviewResponse, error)

	UnsetRecordsUnderReviewWithResponse(ctx context.Context, body UnsetRecordsUnderReviewJSONRequestBody, reqEditors ...RequestEditorFn) (*UnsetRecordsUnderReviewResponse, error)

	// SetRecordsUnderReviewWithBodyWithResponse request with any body
	SetRecordsUnderReviewWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*SetRecordsUnderReviewResponse, error)

	SetRecordsUnderReviewWithResponse(ctx context.Context, body SetRecordsUnderReviewJSONRequestBody, reqEditors ...RequestEditorFn) (*SetRecordsUnderReviewResponse, error)

	// GetHealthWithResponse request
	GetHealthWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetHealthResponse, error)
}

type GetRecordsResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *struct {
		Pagination PaginationResult `json:"pagination"`

		// Records List of log records
		Records []Record `json:"records"`
	}
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r GetRecordsResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetRecordsResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreateRecordsResponse struct {
	Body                      []byte
	HTTPResponse              *http.Response
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r CreateRecordsResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreateRecordsResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type UnsetRecordsUnderReviewResponse struct {
	Body                      []byte
	HTTPResponse              *http.Response
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r UnsetRecordsUnderReviewResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r UnsetRecordsUnderReviewResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type SetRecordsUnderReviewResponse struct {
	Body                      []byte
	HTTPResponse              *http.Response
	ApplicationproblemJSON400 *N400BadRequest
	ApplicationproblemJSON401 *N401Unauthorized
	ApplicationproblemJSON403 *N403Forbidden
	ApplicationproblemJSON404 *N404NotFound
	ApplicationproblemJSON408 *N408RequestTimeout
	ApplicationproblemJSON413 *N413PayloadTooLarge
	ApplicationproblemJSON414 *N414URITooLong
	ApplicationproblemJSON422 *N422UnprocessableEntity
	ApplicationproblemJSON429 *N429TooManyRequests
	ApplicationproblemJSON431 *N431RequestHeaderFieldsTooLarge
	ApplicationproblemJSON500 *N500InternalServerError
	ApplicationproblemJSON503 *N503ServiceUnavailable
	ApplicationproblemJSON505 *N505HTTPVersionNotSupported
}

// Status returns HTTPResponse.Status
func (r SetRecordsUnderReviewResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r SetRecordsUnderReviewResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetHealthResponse struct {
	Body         []byte
	HTTPResponse *http.Response
}

// Status returns HTTPResponse.Status
func (r GetHealthResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetHealthResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// GetRecordsWithResponse request returning *GetRecordsResponse
func (c *ClientWithResponses) GetRecordsWithResponse(ctx context.Context, params *GetRecordsParams, reqEditors ...RequestEditorFn) (*GetRecordsResponse, error) {
	rsp, err := c.GetRecords(ctx, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetRecordsResponse(rsp)
}

// CreateRecordsWithBodyWithResponse request with arbitrary body returning *CreateRecordsResponse
func (c *ClientWithResponses) CreateRecordsWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateRecordsResponse, error) {
	rsp, err := c.CreateRecordsWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateRecordsResponse(rsp)
}

func (c *ClientWithResponses) CreateRecordsWithResponse(ctx context.Context, body CreateRecordsJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateRecordsResponse, error) {
	rsp, err := c.CreateRecords(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateRecordsResponse(rsp)
}

// UnsetRecordsUnderReviewWithBodyWithResponse request with arbitrary body returning *UnsetRecordsUnderReviewResponse
func (c *ClientWithResponses) UnsetRecordsUnderReviewWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*UnsetRecordsUnderReviewResponse, error) {
	rsp, err := c.UnsetRecordsUnderReviewWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseUnsetRecordsUnderReviewResponse(rsp)
}

func (c *ClientWithResponses) UnsetRecordsUnderReviewWithResponse(ctx context.Context, body UnsetRecordsUnderReviewJSONRequestBody, reqEditors ...RequestEditorFn) (*UnsetRecordsUnderReviewResponse, error) {
	rsp, err := c.UnsetRecordsUnderReview(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseUnsetRecordsUnderReviewResponse(rsp)
}

// SetRecordsUnderReviewWithBodyWithResponse request with arbitrary body returning *SetRecordsUnderReviewResponse
func (c *ClientWithResponses) SetRecordsUnderReviewWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*SetRecordsUnderReviewResponse, error) {
	rsp, err := c.SetRecordsUnderReviewWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseSetRecordsUnderReviewResponse(rsp)
}

func (c *ClientWithResponses) SetRecordsUnderReviewWithResponse(ctx context.Context, body SetRecordsUnderReviewJSONRequestBody, reqEditors ...RequestEditorFn) (*SetRecordsUnderReviewResponse, error) {
	rsp, err := c.SetRecordsUnderReview(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseSetRecordsUnderReviewResponse(rsp)
}

// GetHealthWithResponse request returning *GetHealthResponse
func (c *ClientWithResponses) GetHealthWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetHealthResponse, error) {
	rsp, err := c.GetHealth(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetHealthResponse(rsp)
}

// ParseGetRecordsResponse parses an HTTP response from a GetRecordsWithResponse call
func ParseGetRecordsResponse(rsp *http.Response) (*GetRecordsResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetRecordsResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest struct {
			Pagination PaginationResult `json:"pagination"`

			// Records List of log records
			Records []Record `json:"records"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseCreateRecordsResponse parses an HTTP response from a CreateRecordsWithResponse call
func ParseCreateRecordsResponse(rsp *http.Response) (*CreateRecordsResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreateRecordsResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseUnsetRecordsUnderReviewResponse parses an HTTP response from a UnsetRecordsUnderReviewWithResponse call
func ParseUnsetRecordsUnderReviewResponse(rsp *http.Response) (*UnsetRecordsUnderReviewResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &UnsetRecordsUnderReviewResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseSetRecordsUnderReviewResponse parses an HTTP response from a SetRecordsUnderReviewWithResponse call
func ParseSetRecordsUnderReviewResponse(rsp *http.Response) (*SetRecordsUnderReviewResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &SetRecordsUnderReviewResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest N400BadRequest
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 401:
		var dest N401Unauthorized
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON401 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 403:
		var dest N403Forbidden
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON403 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 404:
		var dest N404NotFound
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON404 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 408:
		var dest N408RequestTimeout
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON408 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 413:
		var dest N413PayloadTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON413 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 414:
		var dest N414URITooLong
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON414 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 422:
		var dest N422UnprocessableEntity
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON422 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 429:
		var dest N429TooManyRequests
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON429 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 431:
		var dest N431RequestHeaderFieldsTooLarge
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON431 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest N500InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON500 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 503:
		var dest N503ServiceUnavailable
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON503 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 505:
		var dest N505HTTPVersionNotSupported
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.ApplicationproblemJSON505 = &dest

	}

	return response, nil
}

// ParseGetHealthResponse parses an HTTP response from a GetHealthWithResponse call
func ParseGetHealthResponse(rsp *http.Response) (*GetHealthResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetHealthResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Returns auditlog records
	// (GET /v1/auditlogs)
	GetRecords(w http.ResponseWriter, r *http.Request, params GetRecordsParams)
	// Create auditlog records
	// (POST /v1/auditlogs)
	CreateRecords(w http.ResponseWriter, r *http.Request)
	// Unset auditlog records under review
	// (DELETE /v1/auditlogs/review)
	UnsetRecordsUnderReview(w http.ResponseWriter, r *http.Request)
	// Set auditlog records under review
	// (PUT /v1/auditlogs/review)
	SetRecordsUnderReview(w http.ResponseWriter, r *http.Request)
	// health endpoint for the Audit log API
	// (GET /v1/health)
	GetHealth(w http.ResponseWriter, r *http.Request)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Returns auditlog records
// (GET /v1/auditlogs)
func (_ Unimplemented) GetRecords(w http.ResponseWriter, r *http.Request, params GetRecordsParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Create auditlog records
// (POST /v1/auditlogs)
func (_ Unimplemented) CreateRecords(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Unset auditlog records under review
// (DELETE /v1/auditlogs/review)
func (_ Unimplemented) UnsetRecordsUnderReview(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Set auditlog records under review
// (PUT /v1/auditlogs/review)
func (_ Unimplemented) SetRecordsUnderReview(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// health endpoint for the Audit log API
// (GET /v1/health)
func (_ Unimplemented) GetHealth(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// GetRecords operation middleware
func (siw *ServerInterfaceWrapper) GetRecords(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params GetRecordsParams

	// ------------- Optional query parameter "cursor" -------------

	err = runtime.BindQueryParameter("form", true, false, "cursor", r.URL.Query(), &params.Cursor)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "cursor", Err: err})
		return
	}

	// ------------- Optional query parameter "limit" -------------

	err = runtime.BindQueryParameter("form", true, false, "limit", r.URL.Query(), &params.Limit)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "limit", Err: err})
		return
	}

	// ------------- Optional query parameter "sort_order" -------------

	err = runtime.BindQueryParameter("form", true, false, "sort_order", r.URL.Query(), &params.SortOrder)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sort_order", Err: err})
		return
	}

	// ------------- Optional query parameter "after" -------------

	err = runtime.BindQueryParameter("form", true, false, "after", r.URL.Query(), &params.After)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "after", Err: err})
		return
	}

	// ------------- Optional query parameter "before" -------------

	err = runtime.BindQueryParameter("form", true, false, "before", r.URL.Query(), &params.Before)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "before", Err: err})
		return
	}

	// ------------- Required query parameter "group_id" -------------

	if paramValue := r.URL.Query().Get("group_id"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "group_id"})
		return
	}

	err = runtime.BindQueryParameter("form", true, true, "group_id", r.URL.Query(), &params.GroupId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "group_id", Err: err})
		return
	}

	// ------------- Optional query parameter "id" -------------

	err = runtime.BindQueryParameter("form", false, false, "id", r.URL.Query(), &params.Id)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "id", Err: err})
		return
	}

	// ------------- Optional query parameter "correlation_id" -------------

	err = runtime.BindQueryParameter("form", false, false, "correlation_id", r.URL.Query(), &params.CorrelationId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "correlation_id", Err: err})
		return
	}

	// ------------- Optional query parameter "content_hash" -------------

	err = runtime.BindQueryParameter("form", false, false, "content_hash", r.URL.Query(), &params.ContentHash)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "content_hash", Err: err})
		return
	}

	// ------------- Optional query parameter "service_name" -------------

	err = runtime.BindQueryParameter("form", false, false, "service_name", r.URL.Query(), &params.ServiceName)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "service_name", Err: err})
		return
	}

	// ------------- Optional query parameter "under_review" -------------

	err = runtime.BindQueryParameter("form", true, false, "under_review", r.URL.Query(), &params.UnderReview)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "under_review", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetRecords(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreateRecords operation middleware
func (siw *ServerInterfaceWrapper) CreateRecords(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreateRecords(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// UnsetRecordsUnderReview operation middleware
func (siw *ServerInterfaceWrapper) UnsetRecordsUnderReview(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.UnsetRecordsUnderReview(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// SetRecordsUnderReview operation middleware
func (siw *ServerInterfaceWrapper) SetRecordsUnderReview(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.SetRecordsUnderReview(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetHealth operation middleware
func (siw *ServerInterfaceWrapper) GetHealth(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetHealth(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/auditlogs", wrapper.GetRecords)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/v1/auditlogs", wrapper.CreateRecords)
	})
	r.Group(func(r chi.Router) {
		r.Delete(options.BaseURL+"/v1/auditlogs/review", wrapper.UnsetRecordsUnderReview)
	})
	r.Group(func(r chi.Router) {
		r.Put(options.BaseURL+"/v1/auditlogs/review", wrapper.SetRecordsUnderReview)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/health", wrapper.GetHealth)
	})

	return r
}

type N400BadRequestApplicationProblemPlusJSONResponse Error

type N401UnauthorizedApplicationProblemPlusJSONResponse Error

type N403ForbiddenApplicationProblemPlusJSONResponse Error

type N404NotFoundApplicationProblemPlusJSONResponse Error

type N408RequestTimeoutApplicationProblemPlusJSONResponse Error

type N413PayloadTooLargeApplicationProblemPlusJSONResponse Error

type N414URITooLongApplicationProblemPlusJSONResponse Error

type N422UnprocessableEntityApplicationProblemPlusJSONResponse Error

type N429TooManyRequestsApplicationProblemPlusJSONResponse Error

type N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse Error

type N500InternalServerErrorApplicationProblemPlusJSONResponse Error

type N503ServiceUnavailableApplicationProblemPlusJSONResponse Error

type N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse Error

type GetRecordsRequestObject struct {
	Params GetRecordsParams
}

type GetRecordsResponseObject interface {
	VisitGetRecordsResponse(w http.ResponseWriter) error
}

type GetRecords200JSONResponse struct {
	Pagination PaginationResult `json:"pagination"`

	// Records List of log records
	Records []Record `json:"records"`
}

func (response GetRecords200JSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response GetRecords400ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response GetRecords401ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response GetRecords403ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response GetRecords404ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response GetRecords408ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response GetRecords413ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response GetRecords414ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response GetRecords422ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response GetRecords429ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response GetRecords431ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response GetRecords500ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response GetRecords503ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type GetRecords505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response GetRecords505ApplicationProblemPlusJSONResponse) VisitGetRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecordsRequestObject struct {
	Body *CreateRecordsJSONRequestBody
}

type CreateRecordsResponseObject interface {
	VisitCreateRecordsResponse(w http.ResponseWriter) error
}

type CreateRecords204Response struct {
}

func (response CreateRecords204Response) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.WriteHeader(204)
	return nil
}

type CreateRecords400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response CreateRecords400ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response CreateRecords401ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response CreateRecords403ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response CreateRecords404ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response CreateRecords408ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response CreateRecords413ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response CreateRecords414ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response CreateRecords422ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response CreateRecords429ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response CreateRecords431ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response CreateRecords500ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response CreateRecords503ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type CreateRecords505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response CreateRecords505ApplicationProblemPlusJSONResponse) VisitCreateRecordsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReviewRequestObject struct {
	Body *UnsetRecordsUnderReviewJSONRequestBody
}

type UnsetRecordsUnderReviewResponseObject interface {
	VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error
}

type UnsetRecordsUnderReview204Response struct {
}

func (response UnsetRecordsUnderReview204Response) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.WriteHeader(204)
	return nil
}

type UnsetRecordsUnderReview400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview400ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview401ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview403ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview404ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview408ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview413ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview414ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview422ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview429ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview431ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview500ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview503ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type UnsetRecordsUnderReview505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response UnsetRecordsUnderReview505ApplicationProblemPlusJSONResponse) VisitUnsetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReviewRequestObject struct {
	Body *SetRecordsUnderReviewJSONRequestBody
}

type SetRecordsUnderReviewResponseObject interface {
	VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error
}

type SetRecordsUnderReview204Response struct {
}

func (response SetRecordsUnderReview204Response) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.WriteHeader(204)
	return nil
}

type SetRecordsUnderReview400ApplicationProblemPlusJSONResponse struct {
	N400BadRequestApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview400ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview401ApplicationProblemPlusJSONResponse struct {
	N401UnauthorizedApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview401ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(401)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview403ApplicationProblemPlusJSONResponse struct {
	N403ForbiddenApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview403ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(403)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview404ApplicationProblemPlusJSONResponse struct {
	N404NotFoundApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview404ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(404)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview408ApplicationProblemPlusJSONResponse struct {
	N408RequestTimeoutApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview408ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(408)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview413ApplicationProblemPlusJSONResponse struct {
	N413PayloadTooLargeApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview413ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(413)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview414ApplicationProblemPlusJSONResponse struct {
	N414URITooLongApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview414ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(414)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview422ApplicationProblemPlusJSONResponse struct {
	N422UnprocessableEntityApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview422ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(422)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview429ApplicationProblemPlusJSONResponse struct {
	N429TooManyRequestsApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview429ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(429)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview431ApplicationProblemPlusJSONResponse struct {
	N431RequestHeaderFieldsTooLargeApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview431ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(431)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview500ApplicationProblemPlusJSONResponse struct {
	N500InternalServerErrorApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview500ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview503ApplicationProblemPlusJSONResponse struct {
	N503ServiceUnavailableApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview503ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(503)

	return json.NewEncoder(w).Encode(response)
}

type SetRecordsUnderReview505ApplicationProblemPlusJSONResponse struct {
	N505HTTPVersionNotSupportedApplicationProblemPlusJSONResponse
}

func (response SetRecordsUnderReview505ApplicationProblemPlusJSONResponse) VisitSetRecordsUnderReviewResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/problem+json")
	w.WriteHeader(505)

	return json.NewEncoder(w).Encode(response)
}

type GetHealthRequestObject struct {
}

type GetHealthResponseObject interface {
	VisitGetHealthResponse(w http.ResponseWriter) error
}

type GetHealth200Response struct {
}

func (response GetHealth200Response) VisitGetHealthResponse(w http.ResponseWriter) error {
	w.WriteHeader(200)
	return nil
}

type GetHealth503Response struct {
}

func (response GetHealth503Response) VisitGetHealthResponse(w http.ResponseWriter) error {
	w.WriteHeader(503)
	return nil
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Returns auditlog records
	// (GET /v1/auditlogs)
	GetRecords(ctx context.Context, request GetRecordsRequestObject) (GetRecordsResponseObject, error)
	// Create auditlog records
	// (POST /v1/auditlogs)
	CreateRecords(ctx context.Context, request CreateRecordsRequestObject) (CreateRecordsResponseObject, error)
	// Unset auditlog records under review
	// (DELETE /v1/auditlogs/review)
	UnsetRecordsUnderReview(ctx context.Context, request UnsetRecordsUnderReviewRequestObject) (UnsetRecordsUnderReviewResponseObject, error)
	// Set auditlog records under review
	// (PUT /v1/auditlogs/review)
	SetRecordsUnderReview(ctx context.Context, request SetRecordsUnderReviewRequestObject) (SetRecordsUnderReviewResponseObject, error)
	// health endpoint for the Audit log API
	// (GET /v1/health)
	GetHealth(ctx context.Context, request GetHealthRequestObject) (GetHealthResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHTTPHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHTTPMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// GetRecords operation middleware
func (sh *strictHandler) GetRecords(w http.ResponseWriter, r *http.Request, params GetRecordsParams) {
	var request GetRecordsRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetRecords(ctx, request.(GetRecordsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetRecords")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetRecordsResponseObject); ok {
		if err := validResponse.VisitGetRecordsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// CreateRecords operation middleware
func (sh *strictHandler) CreateRecords(w http.ResponseWriter, r *http.Request) {
	var request CreateRecordsRequestObject

	var body CreateRecordsJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.CreateRecords(ctx, request.(CreateRecordsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "CreateRecords")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(CreateRecordsResponseObject); ok {
		if err := validResponse.VisitCreateRecordsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// UnsetRecordsUnderReview operation middleware
func (sh *strictHandler) UnsetRecordsUnderReview(w http.ResponseWriter, r *http.Request) {
	var request UnsetRecordsUnderReviewRequestObject

	var body UnsetRecordsUnderReviewJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.UnsetRecordsUnderReview(ctx, request.(UnsetRecordsUnderReviewRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "UnsetRecordsUnderReview")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(UnsetRecordsUnderReviewResponseObject); ok {
		if err := validResponse.VisitUnsetRecordsUnderReviewResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// SetRecordsUnderReview operation middleware
func (sh *strictHandler) SetRecordsUnderReview(w http.ResponseWriter, r *http.Request) {
	var request SetRecordsUnderReviewRequestObject

	var body SetRecordsUnderReviewJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.SetRecordsUnderReview(ctx, request.(SetRecordsUnderReviewRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "SetRecordsUnderReview")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(SetRecordsUnderReviewResponseObject); ok {
		if err := validResponse.VisitSetRecordsUnderReviewResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetHealth operation middleware
func (sh *strictHandler) GetHealth(w http.ResponseWriter, r *http.Request) {
	var request GetHealthRequestObject

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetHealth(ctx, request.(GetHealthRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetHealth")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetHealthResponseObject); ok {
		if err := validResponse.VisitGetHealthResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x8W3PbOLLwX0Fx52FSw8jyPfGbIym2viiyP12yJztJKRDZkjAhAQYAZWtS/u+ncOFN",
	"JCU6yXo3p/LgKotAA92NvrPBr47HwohRoFI4F1+dCHMcggSuf32JgW9u8ZJQLAmjnZgLxtWAD8LjJFIP",
	"nQvnEnl6BC04C9HdingrFBko8BEHEQdSILFiceCjOSAOMuYU/BYaAF4DgjCSG7RgHMkVoAXhQip4aKFX",
	"WMDZCQLqMR98JCQndInYAsk7hiLOIuCSgLhAGHkc1HYzLBEWKKbkHkkSgpA4jBCmvprCqAQq0QqLFRKg",
	"aFUIzjd6LAxxC/WWLfRprnf9/fDs/Oj06Pys3XZ/O/zt8Lc/bv9///wO2odf+ove3ZeTm9MpYYM3f/91",
	"9Wo5WuOz16d/zKeLbvDmfvqX9/508z+Hb0eCng3ffIm788GLd97nYPX+5qX4fPiCX3fPBvj47iBcPnNc",
	"hyguamY7rkNxCM6FY1jquI7wVhBixXW5idSI4YLz8OBuH9CAhESWz2eyAhTiexLGIaJxOAeuWGjPpWb7",
	"QC+V392HBY4D6VwcnbrOgvEQS+fCiQmVx0eO69gNnIvDdrvtOiGh9qeb4E2ohCXwKsRvuA+8GnHBuNSH",
	"rqboo1/BHtwVyEzPLxDwG4eFc+H84yAT+QMzKg4UiEHiQaHHQUSMCtBacNJuv8L+CL7EIDR3rRypf3EU",
	"BcTTNBxEnM0DCP/4SyjkvzbcGThndtci8a+wj+ymLvodWsuWi0IcKM5rrdIjSGyoxPcuEuRvQJIxFGC+",
	"BBcRusYByeaFIAReAlpwHBK6dBHjyAcPIknWkM7iLFbMftZyHlznpH04pTiWK8bJ3+A/HeX5XV193rEA",
	"jnwGAlGm9HcNyJCnJgKVFhFlBHz1EwcitSdSMUQqkWEx98CSdvya8TnxfaBPR1e6ZS1R6nEEPCRCKHIk",
	"Q3APXizVCBHJMRkKToZMvmYxfcKDGTKJ9Jau1UKNjrHxmrnI0zZe0TMHtFBTLb9fWFGekBBY/IRqZPdF",
	"dmODuRcQ5Qh8YnCNOPNjDxBOFeGOyBWhRn5IqNiPpf4lgK+BozssUMSVCwFfHdMdJtJQenh8izcBw/6E",
	"sYESvacj1W6MJoyhgTEDuWNCRBjjoNQC0zw1RKA7EgTGzCI8D5QpUVzxQAhL1sl01FckMbp8Qksw6htq",
	"mDJZCmP1JOJsTVQ8oE5B2zxGl6m+W5q2CTg6mlL7QBHYo5LIzVPatNzmyOxePB5FzB0EwXNr4eexeRbT",
	"5EC0SgUBuwMf+bF+JCDEyvwhvXFC6ssJY28x3VjZF09HpjostXPiuUTO1K2wQEKpnTqyUE2ypAtEKMJo",
	"SdZAEQ5ZTKV29CS01vr40C53DdgH/ppA4Iun16/ElBgskEFjW9sylYppolSZLBZOfA4ejgUgIHIFHGGK",
	"CPXJmvgxDtDKbLJQm2hvjYNAQ+cHBPJYEICnnHiwcRHmuSBA8+603e5TCZziYKwx62nqnoxnyebI7I70",
	"9q46baDAE8FNwhPXCsHdSkkCRTGF+wg85WI8Rn2inbxSCpURxGpp8HVwTxkKGQckIvDIgnhpvEMEEjGR",
	"SoUsP44VJsSDKcVrTAI18nTssHuj3OYFsfEwNcEA9QMoCMvvibQQbcnZGrgy9uDrSI7dUW0AQ6yibIqp",
	"B89a6ErxGAeBtjREKDiMJIQR45hvkJBYJlw5vZ5Mbt8BV3HHkMlxHEWMy6eM+hQCyGKAVKSR4lDgUBow",
	"CTOsxzTs2sLGAnxknbflXksnHRYFTYcnGbeHUc47klPSXp9QIolOFNWCsFaccJ0s+dRpczwPiDf7DJuZ",
	"XMXhPOKEViRit3oaegMbNEmnJTmNp5ZbKOaCIWG+SelWWLrb+Z/riHj+F3hyppJXRmcm/SkRYyahjp6E",
	"hjiE79jSPNh9xJq5EzXR5FJfYsKVJP1poKvxdmuY+DFFgmkghUS2wcVXB6hKM/90LjuTm9Fs8v62N5sO",
	"3wxv/jl03MLDcW9UfDLujd71O73cFhmdeosp/UzZHS3zdKqYZYyUmmesvZ7rIpWpmbFUXtAKRxFQxWBY",
	"KDNVTFtK4vQDmFzLtqmoyrTV0+biDiEmQXmRnnqcyJZy+VUCVC2keamsg/whomdlzVBQxSRr7K6xWFUX",
	"JHT1yKLasRUltkBY/+DYU+yCexxGyq84/8bKkSm6DIAu5cq5ODxtV/AMEm+/dVLa6RqiEfY8xn0bp/w5",
	"et1BL09Ozz/+vpIyEhcHB3d3dy2+8J6DTyTjLcaXB3zhqT81r7WSYfCsJCI+SEwCUd76Og4xfc4B+zqs",
	"hfsowKYIlDlvyYy/Yp4Xcw7US2XD+pzWB6qO4oPd5oNjS4MuIguVl6kw00UsXq5UtIkWzIsFYhStIIg0",
	"oVkO6DHOFRdyq7uIYx2R6TxpSdYKxId5vFyq/wg11S/CaOsDrZJUQoVULrhCz0Z9xGEBhiijcLpisSBg",
	"gsOUCfXEV7oCiWVcxW7lGc0g8pgPJu5K6p5qVcbJktDEvZosaifv88W+05cv87W+drtc7XMdSWRQ5ZhW",
	"jEsXrYoCIeIwVMFJcVOkVm3tsgqP5fOehWscl+FyQpKbinnuzD8qtVNm89LzIJKpVSgroXYNWM/StWlr",
	"PIqKZO3RbGUN0i7rl7ddDQ2mxnSXwSzsX2Uw9QodXX3fR6up0f/foPUWqvxogc4ItCPbChUB+Iz4+3BV",
	"0/rdH0ZZsuseomoj4gJdWXhYJM0+T+PQnQV3M1f5/R9GZGH/Wkq7EMDu4/P1jJ/q+AxRe47P0vVzH99r",
	"TALwu0QZ6nms6BuB5Js6mhd6OvJz8xHXANvkY88A7qZiUb39pQF+cL/Hhv1nZKuAsJuwoYHMDdiS0Dq+",
	"B3rwWxKbPQjXojMC9XOfC+J61s/ugkawZp9hP61q1s9O63hDvRVnlPytjbaoo1Zk87TpFk8qfdvViN67",
	"3nBiygyDm6v+0HHzjzqj3uWkN+vcDCejy86kOHjZ6fRuJzWDo97/63XqB9/dvKlb1u6ZFD0KY9Pbbu1Y",
	"tzfo1Y3ZNW97urRSXrA8YFcrD4zfDzvXo5th/19mdFwcfn3ZH/S6s25/PBn1X00n/ZvhbNSbjN5XVm/0",
	"kUwjf0+cFusZP5WjN0TtcfSWrp/W0e92sjktG09fve0XtME+sTo07l8NLyfTUS8bsQpUOaK1Jxupkqwl",
	"Z3HU71aXhl6PO+hKTUD9Lvq9Szh4kvENmo76zwpVIftfayG8lsfCqrw2SptjRrrZRctk4Rgp3MuZt68n",
	"S+e+HqZobmu8kukAiIDtN1DL6HYr/ZKJ2m4s22pFdBbOQb9ZSl6yZN03u5PmPIJVx2x1p5KV/a4pqt0a",
	"3UxZd3h0fHJ6dv7iZdv+Z7qNsjrYkWk+yv8s8ZaDx7hfxTQc+0QGbInslIog0XKbKMBQHZF5EOIoIubd",
	"eEWJeVe5cpyqaUUJexdgUp4ul7l3QglTlbGEbYamaUoz6cF1GIWbhXPxZ4M6a7L/g9tkstm2wcyEHw8f",
	"dThtJ1WLSTpsclNT29OdMvb4EkvRuXl7ezNU7kQbi5vBQDug7PHby+HlVW9UqfS6RhhoZWzgEuKY+Boq",
	"7UjcB5E2KqZmfp+I7QgXdlnlrZLUzphk1zpb5Z7amGD/Gla/6+OU/Utk+lMTZ+xaIlcN2BX17F+iEov6",
	"qGXXgnUprluOKnctM7Ap2I7ocRf4Vj61M9DcvU4hV9kT9O1aqZQJ1Iacu1bJhYW7YuD9S6R26jttae6w",
	"9tnHKuVrBLOl+I1gtgSgIUzhsB9BT8bNBiDbB9AApKiljUDq9PARVGkxewRJzefnDFej+SXl0e5Vh7MN",
	"fFoS9j64TnMHaHpC97my8c101OkZHbyeTG7rW7TVatdSRt+tcfmlPhZfnu1CdHI5mY7zhr12fb2eER+V",
	"X+QA+8P+pH852QfbT97Cb4GPp51Or9fdBz6OPQ/AL4FPh5fTyfXNqP+vfSsUOr+/m99bNO0T2AL/mk3e",
	"wrcJSMYkLQQx9YHPOKwJ3D0uZttKe4jieqpYpejR9mE4SaSX6knu9WIW9RbCyKokKp+gV4bI1LZW4Fw9",
	"IMtEOaY+C2eFlLyYT52eFhKq46qXz+ntifw9EWd8M5rMbkbd3mjW7Y07vWG3P7xy3AoczeUOQu3lodwV",
	"j4prQ7moPrfDZW6D6o0/VmKeWoIS8/p0wRCes9g0B6ykjJBtc7cvp6u7Y0g0w77PQVSUKvu3yI5lV1lM",
	"T/83NrwYhCZWHWMBfIaXlemSbvHRY3u3ri7b5Ogq7FQplRla+XLNtqn/WNvJYJW/3DRgWhkWiW3dakyq",
	"bnfpZr/So9Mzv5XpGoldJS6zfCVntmxhHYUk5wEeX8beh2E9ZplVrMNM5JzLU2JWkqZKt+pW+ekdXrDO",
	"v9aL5valqEomxflJP6GYZu6toko2LdyuLJTnsjuT2R1BQuXZiZPrE6rsEtJRY9lqTftdtD4v+Kz24YuX",
	"i3M4fe69eHH8/Pywffb8xdH50XPPm58vvDlun56fFp3Y8VnRh52VTZ5u21qwCnKTkuCoN56gy9v+B/qB",
	"dooFVdsYgamf1Va3SonC9oqZXqhs1cvbvuM6tnfZuXAOW+1WW4dWEVAcEefCOW61W8dKiLBcafk5WB8e",
	"JMvrB0vQBl/JmI4z+r5z4VyBHJmtNWx2sbcmWsumHFRf/K0Lq+oBzYXUx8PZq5hu7VlYnup7WsnlX6U2",
	"+r0HXkiwXWxrHMSgLzdtRRBV90Y1XOMro4UA8NsQtd3Aj8fUAP4YVK/AxDfb8pq1AupYtlWDSi7QzQyM",
	"5DE0RS5NLSu4iAIidLjS7+r+TRseMrQggQTeQv80fdZE2Ce6E1uA7+rrMkx3cZqRfCRJlpRxE0jeRwHz",
	"wblY4EBANYWatowWIiEUTVNga2Uw53hjPMhGq7+yjc4ugjtZ0vAfJb6UvDw1I/KX9qGKD7bjXsfiwg4q",
	"IGyugAjYWsLyLYwDSaIAUg5hnthzHRpbtdUvv+wFrewKEhFIiXhNctKIrYWmm0cytbIZ4xt4a7M+nSJ+",
	"G2sLK/xXcHYrk30kZytfdzfmrFFIhT6jwcawOaFXv4fVnKAq1zV1hhqbmi9FVH0BYs5YAJg6Dw8ft75V",
	"cNRu77ixVb6ptdXzkDrgvW0P22+n07eqFUnvwIpbzrkowpuch32PVzqKrXCW5+KclIRyWFu+dDYooBQQ",
	"+rmCEeV6xafcq+1P1nUncppdPTPnUnj5jk3z+acEVB88SgMhBfvpqjdBKsJTwd0nEzUWA7slyIEK/Nyq",
	"z7W0ko4AxVeDQWvO/M0/cmd2kH8z/6DZcmIEp+osUgE7KH4Jw3wiognU4XY18aR93AQu95EG88mDJkDZ",
	"dxHMhweawGx/ncBc5G8AWb7tby7LNwHN36g3N9QbQFVfYze3vpuAl66Gm/vVDUB3X8I2V433L1NzH9nc",
	"zG0CXnV919xgbQJde81V3w81V0/0TW+ly6IUE+tKOBMVyZZ53ZPlW7a29or5m+8wyHtNailoT5PRf5OF",
	"rTKqDyUndFJxw48lcZjzy9z8Mje/zE3O3HRs+ahkbR7cYq3nwMaEWrsCkFA2RFMq0rrPVMWRoySM/DEm",
	"iVSZo61EfVGI9HXkSwGMdVKRkEKxFAd/ezZZev/2y0z9MlO/zNQPN1PatJRDjoIiqwAproiPxv/tRumX",
	"Sfplkn6ZpJ/NJI33GyQbQ60AB3K162XZtZlRXVGreL2D7Os7RAQyq29y7NkDENMUpECQeYqA+hEjVKZf",
	"tSssYCpZ5osN5n1ezAMFbL/Y8TVhyZQHDxcnJ8eO66wxJ+oMzDWGbLzYshMwDwcrpptCtr+oMEhsaPJy",
	"S6Hx8eF/AwAA//9lv0syQ1gAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
